var timeout;

function $(id) {
    return document.getElementById(id);
}

function initialize() {
    $("picture").onclick = startPicture;
}

function startPicture() {
    $("ready").style.display = 'none';
    
    var div = $("picture");
    div.style.backgroundColor = 'transparent';
    div.style.backgroundImage = 'url(' + pictureUrl + ')';
    div.onclick = showSolution;

    var audio = new Audio("../background.ogg");
    audio.id = 'audio';
    audio.loop = false;
    audio.play();
    document.body.appendChild(audio);

    $("team_" + startingTeamId + "_score_full").style.display = "inherit";

    $("span").onclick = function() {
        this.onclick = function() { return false; }
        clearTimeout(timeout);
        halfTime();
        fullTime();
    };

    timeout = window.setTimeout(updateBar, 100, 0);
}

function showSolution() {
    fadeOut();

    $("picture").onclick = function() { return false; };
    $("hints").onclick = function() { return false; };

    $("solution").style.display = "block";
    clearTimeout(timeout);
}

function updateBar(promille) {
    var span = $("span");

    span.style.width = (promille/10) + '%';
    
    if (promille == 500) {
        halfTime();
    }

    if (promille < 1000) {
        timeout = window.setTimeout(updateBar, 64, promille+1);
    } else {
        fullTime();
    }
}

function halfTime() {
    span.style.backgroundColor = "#b0b0b0";

    $("team_0_score_reduced").style.display = "inherit";
    $("team_1_score_reduced").style.display = "inherit";

    reducePoints(pointReductionTime);
}

function fullTime() {
    $("picture").classList.add("shrinked");
    window.setTimeout(showHints, 1000);
}

function showHints() {
    fadeOut();
    
    $("hints").style.display = 'inline-block';
    $("hints").onclick = hintClicked;
}

function fadeOut() {
    var audio = $("audio");
    if (audio == null) {
        return;
    }

    var actualVolume = audio.volume;
    var fadeOutInterval = setInterval(function() {
        actualVolume = (parseFloat(actualVolume) - 0.05).toFixed(2);
        if (actualVolume >= 0) {
            audio.volume = actualVolume;
        } else {
            audio.parentNode.removeChild(audio);
            clearInterval(fadeOutInterval);
        }
    }, 70);
}

function hintClicked() {
    $("hint_" + (hint++)).style.display = 'list-item';
    reducePoints(pointReductionHints);
    
    if (hint == 3) {
        $("hints").onclick = function() { return false; };
        $("skip").style.display = 'inherit';
    }
}

function reducePoints(amount) {
    var span = $("points");
    var points = span.innerText;
    
    points = points - amount;
    
    span.innerText = points;
    
    $("team_0_points_reduced").value = points;
    $("team_0_score_reduced").value = "+" + points;

    $("team_1_points_reduced").value = points;
    $("team_1_score_reduced").value = "+" + points;
}
